package getPowerChargeSettingInfo

import (
	"GoSungrow/iSolarCloud/api"
	"GoSungrow/iSolarCloud/api/apiReflect"
	"fmt"
	"github.com/MickMake/GoUnify/Only"
)

const Url = "/v1/powerStationService/getPowerChargeSettingInfo"
const Disabled = false

type RequestData struct {
	PsId api.Integer `json:"ps_id" required:"true"`
}

func (rd RequestData) IsValid() error {
	return apiReflect.VerifyOptionsRequired(rd)
}

func (rd RequestData) Help() string {
	ret := fmt.Sprintf("")
	return ret
}

type ResultData struct {
	ParamIncomeUnit          api.Integer  `json:"param_income_unit"`
	ParamIncomeUnitName      string `json:"param_income_unit_name"`
	PowerElectricalChargeMap struct {
		DefaultCharge      api.Float   `json:"default_charge" PointUnit:"$"`
		IntervalTimeCharge interface{} `json:"interval_time_charge"`
	} `json:"powerElectricalChargeMap"`
	PowerSelfUseTimesChargeMap struct {
		DefaultCharge      api.Float `json:"default_charge" PointUnit:"$"`
		IntervalTimeCharge string  `json:"interval_time_charge"`
	} `json:"powerSelfUseTimesChargeMap"`
	PsID api.Integer `json:"ps_id"`
}

func (e *ResultData) IsValid() error {
	var err error
	// switch {
	// case e.Dummy == "":
	// 	break
	// default:
	// 	err = errors.New(fmt.Sprintf("unknown error '%s'", e.Dummy))
	// }
	return err
}

//type DecodeResultData ResultData
//
//func (e *ResultData) UnmarshalJSON(data []byte) error {
//	var err error
//
//	for range Only.Once {
//		if len(data) == 0 {
//			break
//		}
//		var pd DecodeResultData
//
//		// Store ResultData
//		_ = json.Unmarshal(data, &pd)
//		e.Dummy = pd.Dummy
//	}
//
//	return err
//}

func (e *EndPoint) GetData() api.DataMap {
	entries := api.NewDataMap()

	for range Only.Once {
		pkg := apiReflect.GetName("", *e)
		entries.StructToPoints(e.Response.ResultData, pkg, "system", api.NewDateTime(""))
	}

	return entries
}
